//+------------------------------------------------------------------------------------------------------------------+
//|                                                                                        ZI_File_Functions_Full.mqh|
//|                                                                                        Copyright © Zhunko |
//|                                                                                        ZHUNKO    vadim@zhunko.ru |
//|24.10.2008                                                                              Ilnur     X-79@yandex.ru  |
//+------------------------------------------------------------------------------------------------------------------+
//|                                      SET UNLIMITED File functions. |
//+------------------------------------------------------------------------------------------------------------------+
//|    Basic file functions. |
//+------------------------------------------------------------------------------------------------------------------+
//| 1. The function opens or creates the file. |
//| 2. Function move file pointer. |
//| 3. Recording function in the file double-precision values. |
//| 4. Function to read from the file double-precision values. |
//| 5. Function to a file of integer values. |
//| 6. Function of reading from a file of integer values. |
//| 7. The function writes a string to a binary file with the current position. |
//| 8. The function reads a line from the current file position. |
//| 9. Function close the file. |
//|10. Function delete a file. |
//+------------------------------------------------------------------------------------------------------------------+
//|   Options file operations for reading and writing data. |
//+------------------------------------------------------------------------------------------------------------------+
//|11.Function Operations for a binary data file, double-precision. |
//|12.Function Operations for binary data array of double precision. |
//|13.The &#39;Operation to binary integer data. |
//|14.Function Operations for binary array of integer data. |
//|15.Function Operations for binary string data. " |
//|16.Function Operations for binary array of string data. " |
//+------------------------------------------------------------------------------------------------------------------+
//|    Additional file functions. |
//+------------------------------------------------------------------------------------------------------------------+
//|17. Detection function of the file pointer at the end of the file. |
//|18. The function of the file pointer. |
//|19. Function to copy a file. |
//|20. Function move the file. |
//|21. The function creates a new directory. |
//|22. The function removes an existing directory. |
//|23. The function returns a system error. |
//|24. The function returns a string description of the code system error. |
//+------------------------------------------------------------------------------------------------------------------+
#define FILE_CREATE_    0 // Create or overwrite a file.
#define FILE_WRITE_     1 // Append file.
#define FILE_READ_      2 // Read the file.
#define FILE_WRITE_END_ 3 // Append file to the end.
 //+zhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzh +
 //|zhzhzhzh main file functions. zhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzh |
 //+zhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzh +
#import "ZI_File_Functions_Full_Main_Lib 0-81024.ex4"
 //====================================================================================================================================
 // 1. The function opens or creates a file .============================================ =================================================
 // The function opens / creates a file for input and / or withdrawal. If the file name contains non-existing directory, then the function returns an error.
 // To create a directory using the function "CreateDirectory ()".
 // The function returns: handle - file descriptor, if the function is implemented without error;
 //                     -1     - system error occurred;
 //                     -2     - Failed to move file pointer to end of file;
 //                     -3     - an invalid way to open the file.
 int FileOpenFull (string PathName, // File name with absolute path.
                   int    ModeCWR); // Method for opening file:
                                    // 0 - FILE_CREATE_    Opening file for writing. If the file exists, then the contents of the file will be
                                    //                     destroyed. If a file with that name does not exist, then it will create.
                                    // 1 - FILE_WRITE_     Append or overwrite the file. The data will be changed.
                                    // 2 - FILE_READ_      Opening a file for reading. If the file does not exist, the function returns an error.
                                    // 3 - FILE_WRITE_END_ Opening a file for reading and adding new data. New data will be
                                    //                     recorded at the end of the file. If the file does not exist, the function returns an error.
 //====================================================================================================================================
 // 2. Function move file pointer .============================================= ===========================================
 // The function moves the file pointer to the new position, which is offset in bytes from the beginning, end or current position
 // file. Next read or write occurs to the new position. If moving the file pointer is successful, the new position
 // file pointer, otherwise returns -1.
 int FileSeekFull (int Handle,  // File descriptor returned by "FileOpenFull ()".
                   int Offset,  // Offset in bytes.
                   int Origin); // The initial position of file pointer: SEEK_CUR - from the current situation,
                                //                                          SEEK_SET - from the beginning,
                                //                                          SEEK_END - from the end of the file.
 //====================================================================================================================================
#import "ZI_File_Functions_Full_Double_Data_Lib 0-81024.ex4"
 //====================================================================================================================================
 // 3. The function writes the number of double precision binary file .========================================= =============================
 // Returns the actual number of bytes written or a negative value in case of error.
 int FileWriteDoubleFull (int    Handle, // File descriptor returned by "FileOpenFull ()".
                          double Value,  // The value of double precision.
                          int    Size);  // Flag size: DOUBLE_VALUE (8 bytes);
                                         //               FLOAT_VALUE  (4 bytes).
 //====================================================================================================================================
 // 4. The function reads the double-precision number from the current position of the binary file .======================================= ================
 double FileReadDoubleFull (int Handle, // File descriptor returned by "FileOpenFull ()".
                            int Size);  // Flag size: DOUBLE_VALUE (8 bytes);
                                        //               FLOAT_VALUE  (4 bytes).
 //====================================================================================================================================
#import "ZI_File_Functions_Full_Intenger_Data_Lib 0-81024.ex4"
 //====================================================================================================================================
 // 5. The function writes an integer to a binary file .========================================== =======================================
 // Returns the actual number of bytes written or a negative value in case of error.
 int FileWriteIntegerFull (int Handle, // File descriptor returned by "FileOpenFull ()".
                           int Value,  // The value of double precision.
                           int Size);  // Flag size: CHAR_VALUE (1 byte);
                                       //               SHORT_VALUE (2 bytes)
                                       //               LONG_VALUE  (4 bytes).
 //====================================================================================================================================
 // 6. The function reads an integer from the current position of the binary file .======================================== ==========================
 int FileReadIntegerFull (int Handle, // File descriptor returned by "FileOpenFull ()".
                          int Size);  // Flag size: CHAR_VALUE (1 byte);
                                      //               SHORT_VALUE (2 bytes)
                                      //               LONG_VALUE  (4 bytes).
 //====================================================================================================================================
#import "ZI_File_Functions_Full_String_Value_Lib 0-81024.ex4"
 //====================================================================================================================================
 // 7. The function writes a string to a binary file from the current position .======================================== ============================
 // Returns the actual number of bytes written or a negative value in case of error.
 int FileWriteStringFull (int    Handle, // File descriptor returned by "FileOpenFull ()".
                          string Value,  // The string to write.
                          int    Size);  // The length of the recorded line.
 //====================================================================================================================================
 // 8. The function reads a line from the current file position .========================================== ========================================
 string FileReadStringFull (int Handle,  // File descriptor returned by "FileOpenFull ()".
                            int Length); // Number of characters to read.
 //====================================================================================================================================
#import "ZI_File_Functions_Full_Main_Lib 0-81024.ex4"
 //====================================================================================================================================
 // 9. Function close the file .============================================== ================================================== =========
 // The function closes the previously opened file. If the file is closed successfully, the function returns TRUE, otherwise returns FALSE.
 bool FileCloseFull (int Handle); // File descriptor returned by "FileOpenFull ()".
 //====================================================================================================================================
 //10. Function to delete a file .============================================== ================================================== =========
 // The function deletes an existing file. If the file is deleted successfully, the function returns TRUE, otherwise returns FALSE.
 int FileDeleteFull (string PathName); // Full name of the deleted file.
 //+zhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzh +
 //|zhzhzhzh Options file operations for reading and writing data. zhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzh |
 //+zhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzh +
#import "ZI_File_Functions_Full_Double_Data_Lib 0-81024.ex4"
 //====================================================================================================================================
 //11. Function Operations for a binary data file, double-precision ".======================================= ==========================
 // When you create and record returns the number of bytes read or written. In the case of unsuccessful completing its function returns "-1".
 // While reading returns the value read.
 double FileOperationsDoubleValue (string  PathName,        // Filename.
                                   double& Value,           // Variable for writing or reading.
                                   int     Size,            // Flag size: DOUBLE_VALUE (8 bytes);
                                                            //               FLOAT_VALUE  (4 bytes).
                                   int     ModeCWR,         // Type produced by action on a file: 0 - FILE_CREATE_ create or overwrite a file;
                                                            //                                     1 - FILE_WRITE_   append file;
                                                            //                                     2 - FILE_READ_    read the file.
                                   int     Offset,          // Offset in bytes of the file pointer.
                                   int     Origin,          // The initial position of file pointer: SEEK_CUR - from the current situation,
                                                            //                                          SEEK_SET - from the beginning,
                                                            //                                          SEEK_END - from the end of the file).
                                   int&    ArOutputByte[]); // The number of bytes read or written.
 //====================================================================================================================================
 //12. Function Operations for binary data array double precision ".====================================== ===================
 // Returns the number of recorded items. In the case of unsuccessful completing its function returns "-1".
 int FileOperationsDoubleArray (string  PathName, // Filename.
                                double& Array[],  // Array for recording or reading.
                                int     ModeCWR,  // Type produced by action on a file: 0 - FILE_CREATE_ create or overwrite a file;
                                                  //                                     1 - FILE_WRITE_   append file;
                                                  //                                     2 - FILE_READ_    read the file.
                                int     Start,    // Start position to write to the array or to read from the array.
                                int     Count,    // Number of elements to write or read in the light of all the measurements.
                                int     Offset,   // Offset in bytes of the file pointer.
                                int     Origin);  // The initial position of file pointer: SEEK_CUR - from the current situation,
                                                  //                                          SEEK_SET - from the beginning,
                                                  //                                          SEEK_END - from the end of the file).
 //====================================================================================================================================
#import "ZI_File_Functions_Full_Intenger_Data_Lib 0-81024.ex4"
 //====================================================================================================================================
 //13. The &#39;Operation to binary integer data ".======================================== ============================
 // When you create and record returns the number of bytes read or written. In the case of unsuccessful completing its function returns "-1".
 // While reading returns the value read.
 int FileOperationsIntValue (string PathName,        // Filename.
                             int&   Value,           // Variable for writing or reading.
                             int    Size,            // Flag size: CHAR_VALUE (1 byte);
                                                     //               SHORT_VALUE (2 bytes)
                                                     //               LONG_VALUE  (4 bytes).
                             int    ModeCWR,         // Type produced by action on a file: 0 - FILE_CREATE_ create or overwrite a file;
                                                     //                                     1 - FILE_WRITE_   append file;
                                                     //                                     2 - FILE_READ_    read the file.
                             int    Offset,          // Offset in bytes of the file pointer.
                             int    Origin,          // The initial position of file pointer: SEEK_CUR - from the current situation,
                                                     //                                          SEEK_SET - from the beginning,
                                                     //                                          SEEK_END - from the end of the file).
                            int&   ArOutputByte[]);  // The number of bytes read or written.
 //====================================================================================================================================
 //14. Function Operations for binary array of integer data ".======================================= =====================
 // Returns the number of recorded items. In the case of unsuccessful completing its function returns "-1".
 int FileOperationsIntArray (string PathName, // Filename.
                             int&   Array[],  // Array for recording or reading.
                             int    ModeCWR,  // Type produced by action on a file: 0 - FILE_CREATE_ create or overwrite a file;
                                              //                                     1 - FILE_WRITE_   append file;
                                              //                                     2 - FILE_READ_    read the file.
                             int    Start,    // Start position to write to the array or to read from the array.
                             int    Count,    // Number of elements to write or read in the light of all the measurements.
                             int    Offset,   // Offset in bytes of the file pointer.
                             int    Origin);  // The initial position of file pointer: SEEK_CUR - from the current situation,
                                              //                                          SEEK_SET - from the beginning,
                                              //                                          SEEK_END - from the end of the file).
 //====================================================================================================================================
#import "ZI_File_Functions_Full_String_Value_Lib 0-81024.ex4"
 //====================================================================================================================================
 //15. Function Operations for binary string data ".======================================== ================================
 // Returns the number of bytes written. In the case of unsuccessful completing its function returns "-1".
 int FileOperationsStringValue (string  PathName, // Filename.
                                string& Value,    // Variable for writing or reading.
                                int     ModeCWR,  // Type produced by action on a file: 0 - FILE_CREATE_ create or overwrite a file;
                                                  //                                     1 - FILE_WRITE_   append file;
                                                  //                                     2 - FILE_READ_    read the file.
                                int     Size,     // The length of the recording or read a line.
                                int     Offset,   // Offset in bytes of the file pointer.
                                int     Origin);  // The initial position of file pointer: SEEK_CUR - from the current situation,
                                                  //                                          SEEK_SET - from the beginning,
                                                  //                                          SEEK_END - from the end of the file).
 //====================================================================================================================================
#import "ZI_File_Functions_Full_String_Array_Lib 0-81015.ex4"
 //====================================================================================================================================
 //16. Function Operations for binary array of string data ".======================================= =========================
 // Returns the number of bytes written. In the case of unsuccessful completing its function returns "-1".
 int FileOperationsStringArray (string  PathName, // Filename.
                                string& Array[],  // Array for recording or reading.
                                int     ModeCWR,  // Type produced by action on a file: 0 - FILE_CREATE_ create or overwrite a file;
                                                  //                                     1 - FILE_WRITE_   append file;
                                                  //                                     2 - FILE_READ_    read the file.
                                int     Start,    // Start position to write to the array or to read from the array.
                                int     Count,    // Number of elements to write or read in the light of all the measurements.
                                int     Offset,   // Offset in bytes of the file pointer.
                                int     Origin);  // The initial position of file pointer: SEEK_CUR - from the current situation,
                                                  //                                          SEEK_SET - from the beginning,
                                                  //                                          SEEK_END - from the end of the file).
 //+zhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzh +
 //|zhzhzhzh Additional file functions. zhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzh |
 //+zhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzh +
#import "ZI_File_Functions_Full_Main_Lib 0-81024.ex4"
 //====================================================================================================================================
 // 5. Detection function of the file pointer at end of file .========================================= =======================
 // The function returns TRUE, if the pointer is at the end of the file, otherwise it returns FALSE.
 bool FileIsEndingFull (int Handle); // File descriptor returned by "FileOpenFull ()".
 //====================================================================================================================================
 // 6. Function of file pointer .============================================= =============================================
 // The function returns the offset of the current position of file pointer from the beginning of the file.
 int FileTellFull (int Handle);
 //====================================================================================================================================
 // 7. 
 // The function copies the file from one specified place to another. If the file exists, the function overwrites it.
 // The old data is destroyed. If the file name contains non-existing directory, then the function returns an error.
 // To create a directory using the function "CreateDirectory ()". If the file is copied successfully, the function returns TRUE,
 // otherwise returns FALSE.
 bool FileCopy (string ExistingFileName, // The full name of the file being copied.
                string NewFileName);     // Full path in which to copy the source file.
 //====================================================================================================================================
 // 8. Function move a file .============================================== ================================================== ======
 // The function moves the file from one specified place to another. If the file exists, then the function returns an error.
 // If the file name contains non-existing directory, then the function returns an error.
 // To create a directory using the function "CreateDirectory ()".
 // If the file is moved successfully, the function returns TRUE, otherwise returns FALSE.
 int FileMove (string ExistingFileName, // The full name of the moved file.
               string NewFileName);     // Full path where will be moved to the original file.
 //====================================================================================================================================
 // 9. Function creates a new directory .============================================= ==================================================
 // If the directory creation is successful, the function returns TRUE, otherwise returns FALSE.
 bool CreateDirectory (string PathName); // The path to the directory.
 //====================================================================================================================================
 //10. The function removes an existing directory .============================================= ===========================================
 // If you delete the directory was successful, the function returns TRUE, otherwise returns FALSE.
 bool RemoveDirectory (string PathName); // The path to the directory.
 //====================================================================================================================================
 //11. The function returns a system error code .============================================ ============================================
 int SystemError();
 //====================================================================================================================================
 //12. The function returns a string description of the code system error .========================================== ==========================
 string StringError (int ErrorCode); // System error code.
//=====================================================================================================================================
#import
//zhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzhzh